﻿//////////////////////////////////////////////
// OutputFormatter.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkDebug
{
	struct TestClassObserverInformation ;
	struct TestFunctionObserverInformation ;
}

/// Includes ---------------------------------

// nkDebug
#include "../../Dll/DllDefines.h"

// nkLog
#include <NilkinsLog/Data/String.h>

/// Class ------------------------------------

namespace nkDebug
{
	class DLL_NKDEBUG_EXPORT OutputFormatter
	{
		public :

			// Constructor, destructor
			OutputFormatter () ;
			virtual ~OutputFormatter () ;

			// Formatting
			virtual nkLog::String formatClassLaunch (const TestClassObserverInformation& info) ;
			virtual nkLog::String formatClassBypass (const TestClassObserverInformation& info) ;
			virtual nkLog::String formatClassEnd (const TestClassObserverInformation& info) ;
			virtual nkLog::String formatTestLaunch (const TestFunctionObserverInformation& info) ;
			virtual nkLog::String formatTestBypass (const TestFunctionObserverInformation& info) ;
			virtual nkLog::String formatTestSuccess (const TestFunctionObserverInformation& info) ;
			virtual nkLog::String formatTestFailure (const TestFunctionObserverInformation& info) ;
	} ;
}