﻿//////////////////////////////////////////////
// FunctionSet.h
// 
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkDebug
{
	struct FunctionDescriptor ;
}

/// Includes ---------------------------------

// nkDebug
#include "../Dll/DllDefines.h"

// nkLog
#include <NilkinsLog/Data/StringView.h>

// Standards
#include <functional>

/// Class ------------------------------------

namespace nkDebug
{
	class DLL_NKDEBUG_EXPORT FunctionSet final
	{
		private :

			// Attributes
			// Manually managing the pool to avoid templated vector
			FunctionDescriptor* _set ;
			unsigned int _setSize ;

		public :

			// Constructor, destructor
			FunctionSet () ;
			~FunctionSet () ;

			// Pool management
			const std::function<bool ()>& registerFunction (const char* name, const std::function<bool ()>& func) ;
			nkLog::StringView getFunctionName (unsigned int index) const ;
			const std::function<bool ()>& getFunction (unsigned int index) const ;
			unsigned int getSetSize () const ;
	} ;
}