﻿//////////////////////////////////////////////
// LogManager.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkLog
{
	class Logger ;
}

/// Includes ---------------------------------

// nkMemory
#include "../Dll/DllDefines.h"

#include "../Containers/StringView.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Class ------------------------------------

namespace nkMemory
{	
	class DLL_MEMORY_EXPORT LogManager final : public nkCommon::SingletonClass<LogManager>
	{
		friend class nkCommon::SingletonClass<LogManager> ;

		private :

			// Le logger enregistré
			nkLog::Logger* _receiver ;

		private :

			// Constructeur, destructeur
			LogManager () ;
			~LogManager () ;

		public :

			// Getters
			nkLog::Logger* getReceiver () const ;

			// Setters
			void setReceiver (nkLog::Logger* receiver) ;			

			// Log
			void log (const StringView& message, const StringView& className) ;
	} ;
}