﻿//////////////////////////////////////////////
// ThreadSubmittedWork.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkTasks
{
	class Task ;
	class Thread ;
}

/// Includes ---------------------------------

// nkTasks
#include "../Dll/DllDefines.h"

// Standards
#include <cstddef>

/// Class ------------------------------------

namespace nkTasks
{
	class DLL_TASKS_EXPORT ThreadSubmittedWork final
	{
		private :

			// Attributes
			// Task soumise
			Task* _task ;
			// ID Task dans son environnement
			size_t _taskId ;
			// Thread parent
			Thread* _parentThread ;

		public :

			// Constructeur, destructeur
			ThreadSubmittedWork (Task* task, size_t taskId, Thread* parentThread) ;
			ThreadSubmittedWork (const ThreadSubmittedWork& other) ;
			~ThreadSubmittedWork () ;

			// Getters
			Task* getTask () const ;
			size_t getTaskId () const ;
			Thread* getParentThread () const ;

			// Contrôle flow
			bool cancel () ;

			// Operators
			bool operator== (const ThreadSubmittedWork& other) const ;
	} ;
}